import { __assign } from "tslib";
import React, { Fragment } from 'react';
import { isDate } from '../../context';
import { CUSTOM_MESSAGE_TYPE } from '../../constants/messageTypes';
import { Message } from '../Message/Message';
export function defaultRenderMessages(_a) {
    var components = _a.components, customClasses = _a.customClasses, lastReceivedId = _a.lastReceivedMessageId, messageGroupStyles = _a.messageGroupStyles, messages = _a.messages, ownReadState = _a.ownReadState, readData = _a.readData, messageProps = _a.sharedMessageProps;
    var DateSeparator = components.DateSeparator, HeaderComponent = components.HeaderComponent, MessageSystem = components.MessageSystem, UnreadMessagesSeparator = components.UnreadMessagesSeparator;
    return messages.map(function (message, index) {
        if (message.customType === CUSTOM_MESSAGE_TYPE.date && message.date && isDate(message.date)) {
            return (React.createElement("li", { key: "".concat(message.date.toISOString(), "-i") },
                React.createElement(DateSeparator, { date: message.date, formatDate: messageProps.formatDate, unread: message.unread })));
        }
        if (message.customType === CUSTOM_MESSAGE_TYPE.intro && HeaderComponent) {
            return (React.createElement("li", { key: 'intro' },
                React.createElement(HeaderComponent, null)));
        }
        if (message.type === 'system') {
            return (React.createElement("li", { key: message.id || message.created_at },
                React.createElement(MessageSystem, { message: message })));
        }
        var groupStyles = messageGroupStyles[message.id] || '';
        var messageClass = (customClasses === null || customClasses === void 0 ? void 0 : customClasses.message) || "str-chat__li str-chat__li--".concat(groupStyles);
        var isNewestMessage = index === messages.length - 1;
        var isLastReadMessage = (ownReadState === null || ownReadState === void 0 ? void 0 : ownReadState.last_read_message_id) === message.id;
        var showUnreadSeparator = isLastReadMessage &&
            !isNewestMessage &&
            ((ownReadState === null || ownReadState === void 0 ? void 0 : ownReadState.first_unread_message_id) || (ownReadState === null || ownReadState === void 0 ? void 0 : ownReadState.unread_messages) > 0); // unread count can be 0 if the user marks unread only own messages
        return (React.createElement(Fragment, { key: message.id || message.created_at },
            React.createElement("li", { className: messageClass, "data-message-id": message.id, "data-testid": messageClass },
                React.createElement(Message, __assign({ groupStyles: [groupStyles], lastReceivedId: lastReceivedId, message: message, readBy: readData[message.id] || [] }, messageProps))),
            showUnreadSeparator && UnreadMessagesSeparator && (React.createElement("li", { className: 'str-chat__li str-chat__unread-messages-separator-wrapper' },
                React.createElement(UnreadMessagesSeparator, { unreadCount: ownReadState.unread_messages })))));
    });
}
