import { __assign, __rest } from "tslib";
import React, { useMemo } from 'react';
import clsx from 'clsx';
import { Modal } from '../Modal';
import { useFetchReactions } from './hooks/useFetchReactions';
import { LoadingIndicator } from '../Loading';
import { Avatar } from '../Avatar';
export function ReactionsListModal(_a) {
    var _b;
    var handleFetchReactions = _a.handleFetchReactions, onSelectedReactionTypeChange = _a.onSelectedReactionTypeChange, reactions = _a.reactions, selectedReactionType = _a.selectedReactionType, modalProps = __rest(_a, ["handleFetchReactions", "onSelectedReactionTypeChange", "reactions", "selectedReactionType"]);
    var selectedReaction = reactions.find(function (_a) {
        var reactionType = _a.reactionType;
        return reactionType === selectedReactionType;
    });
    var SelectedEmojiComponent = (_b = selectedReaction === null || selectedReaction === void 0 ? void 0 : selectedReaction.EmojiComponent) !== null && _b !== void 0 ? _b : null;
    var _c = useFetchReactions({
        handleFetchReactions: handleFetchReactions,
        shouldFetch: modalProps.open,
    }), areReactionsLoading = _c.isLoading, allReactions = _c.reactions;
    var currentReactions = useMemo(function () {
        if (!selectedReactionType) {
            return [];
        }
        return allReactions.filter(function (reaction) { return reaction.type === selectedReactionType && reaction.user; });
    }, [allReactions, selectedReactionType]);
    return (React.createElement(Modal, __assign({}, modalProps),
        React.createElement("div", { className: 'str-chat__message-reactions-details', "data-testid": 'reactions-list-modal' },
            React.createElement("div", { className: 'str-chat__message-reactions-details-reaction-types' }, reactions.map(function (_a) {
                var EmojiComponent = _a.EmojiComponent, reactionCount = _a.reactionCount, reactionType = _a.reactionType;
                return EmojiComponent && (React.createElement("div", { className: clsx('str-chat__message-reactions-details-reaction-type', {
                        'str-chat__message-reactions-details-reaction-type--selected': selectedReactionType === reactionType,
                    }), "data-testid": "reaction-details-selector-".concat(reactionType), key: reactionType, onClick: function () { return onSelectedReactionTypeChange === null || onSelectedReactionTypeChange === void 0 ? void 0 : onSelectedReactionTypeChange(reactionType); } },
                    React.createElement("span", { className: 'emoji str-chat__message-reaction-emoji' },
                        React.createElement(EmojiComponent, null)),
                    "\u00A0",
                    React.createElement("span", { className: 'str-chat__message-reaction-count' }, reactionCount)));
            })),
            SelectedEmojiComponent && (React.createElement("div", { className: 'emoji str-chat__message-reaction-emoji str-chat__message-reaction-emoji-big' },
                React.createElement(SelectedEmojiComponent, null))),
            React.createElement("div", { className: 'str-chat__message-reactions-details-reacting-users', "data-testid": 'all-reacting-users' }, areReactionsLoading ? (React.createElement(LoadingIndicator, null)) : (currentReactions.map(function (_a) {
                var user = _a.user;
                return (React.createElement("div", { className: 'str-chat__message-reactions-details-reacting-user', key: user === null || user === void 0 ? void 0 : user.id },
                    React.createElement(Avatar, { "data-testid": 'avatar', image: user === null || user === void 0 ? void 0 : user.image, name: (user === null || user === void 0 ? void 0 : user.name) || (user === null || user === void 0 ? void 0 : user.id) }),
                    React.createElement("span", { className: 'str-chat__user-item--name', "data-testid": 'reaction-user-username' }, (user === null || user === void 0 ? void 0 : user.name) || (user === null || user === void 0 ? void 0 : user.id))));
            }))))));
}
